<?php
namespace Folha\Entities;

use Estoque\Logic\FechamentoDia\Util;
use HCM\Util\DateUtil;

class MigParcnegocio extends Base\MigParcnegocio
{

    const EXPRESSAO_NUMEROS = '/[^0-9]/';

    protected $dtultatu;
    protected $dtinclusao;
    protected $dtnascifundparc;

    /**
     * @param $nrparcnegocio
     * @return \Folha\Entities\MigParcnegocio
//     */
//    public function setNrparcnegocio ($nrparcnegocio) {
//        $nrparcnegocio = \Importacao\Logic\Validacoes::verificaChaveDuplicada('PARCNEGOCIO', 'NRPARCNEGOCIO', \FPA::getNrorgTrabalho(), $nrparcnegocio);
//        $this->nrparcnegocio = $nrparcnegocio;
//    }

    /**
     * @param $nmprincipalparc
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio
     */
    public function setNmprincipalparc ($nmprincipalparc) {
        if ($nmprincipalparc == '' || empty($nmprincipalparc)) {
            $this->nmprincipalparc = 'NÃO CONSTA';
//            throw new \Exception("Campo Obrigatório: 'Descrição/Nome'");
        } else {
            $this->nmprincipalparc = $nmprincipalparc;
        }
    }

    /**
     * @param $nmsecundariparc
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio
     */
    public function setNmsecundariparc ($nmsecundariparc) {
        if ($nmsecundariparc == '' || empty($nmsecundariparc)) {
            $this->nmsecundariparc = 'NÃO CONSTA';
//            throw new \Exception("Campo Obrigatório: 'Descrição/Nome'");
        } else {
            $this->nmsecundariparc = $nmsecundariparc;
        }
    }

    /**
     * @param $nrinscricaoparc
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio
     */
    public function setNrinscricaoparc ($nrinscricaoparc) {
        $nrinscricaoparc = preg_replace(self::EXPRESSAO_NUMEROS, "",$nrinscricaoparc);
//        if (empty($nrinscricaoparc) || preg_match(self::EXPRESSAO_NUMEROS, $nrinscricaoparc)) {
//            throw new \Exception("Campo Obrigatório: 'CNPJ/CPF'");
//        }
        if ($nrinscricaoparc == '' || empty($nrinscricaoparc)) {
            $this->nrinscricaoparc = '00000000000';
        } else {
            $this->nrinscricaoparc = $nrinscricaoparc;
        }

    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param mixed $dtnascifundparc
     * @throws \Exception
     * @return \Folha\Entities\MigParcnegocio|void
     */
    public function setDtnascifundparc($dtnascifundparc)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtnascifundparc)) {
            if (!empty($dtnascifundparc)) {
                throw new \Exception("Data de Nascimento: Data '$dtnascifundparc' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtnascifundparc instanceof \DateTime)) {
            $dtnascifundparc = DateUtil::getDataDeString($dtnascifundparc);
        }

        $this->dtnascifundparc = $dtnascifundparc;
    }
}