<?php

require_once 'base/GepMotivofluxoEntityBase.php';

/**
 * GepMotivoFluxoEntity.
 *
 * @package Entity
 * @author  daniellepereira <username@example.com>
 */
class GepMotivofluxoEntity extends GepMotivofluxoEntityBase
{

    const SEM_REGISTRO = 10;


    /**
    * Descri??o: Gera o novo c?digo de Motivo de Tramita??o por Tipo de Fluxo.
    *
    * @param integer $nrorg N?mero da Organiza??o.
    *
    * @return $codigo integer
    */
    public static function retornaProxNumeroMotivoFluxo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_MOTIVOFLUXO', 10);
        return $codigo;
    }


    /** Retorna dados de um motivo atraves do tipo de fluxo.
     *
     * @throws Exception             Consulta sem registro.
     * @param  integer $nrorg        Numero da organizacao.
     * @param  integer $nrtipofluxo  Numero do tipo de fluxo.
     *
     * @return object  $consulta     Dados da consulta.
     */
    public static function retornaMotivo($nrorg, $nrtipofluxo){
        $consulta = GepMotivofluxo::consultaMotivo($nrorg, $nrtipofluxo);
        if ($consulta instanceof GepMotivofluxoEntity) {
            return $consulta;
        }

        throw new Exception('Nao ha registro de motivo parametrizado para este tipo de fluxo', self::SEM_REGISTRO);

    }


}